diff -crN linux-3.8.6-gentoo/drivers/hv/hv.c linux-3.8.6-gentoo-hyperv/drivers/hv/hv.c
*** linux-3.8.6-gentoo/drivers/hv/hv.c	Tue Feb 19 08:58:34 2013
--- linux-3.8.6-gentoo-hyperv/drivers/hv/hv.c	Sat Apr 13 02:24:31 2013
***************
*** 27,32 ****
--- 27,33 ----
  #include <linux/vmalloc.h>
  #include <linux/hyperv.h>
  #include <linux/version.h>
+ #include <linux/interrupt.h>
  #include <asm/hyperv.h>
  #include "hyperv_vmbus.h"
  
***************
*** 34,46 ****
  struct hv_context hv_context = {
  	.synic_initialized	= false,
  	.hypercall_page		= NULL,
- 	.signal_event_param	= NULL,
- 	.signal_event_buffer	= NULL,
  };
  
  /*
   * query_hypervisor_info - Get version info of the windows hypervisor
   */
  static int query_hypervisor_info(void)
  {
  	unsigned int eax;
--- 35,50 ----
  struct hv_context hv_context = {
  	.synic_initialized	= false,
  	.hypercall_page		= NULL,
  };
  
  /*
   * query_hypervisor_info - Get version info of the windows hypervisor
   */
+ unsigned int host_info_eax;
+ unsigned int host_info_ebx;
+ unsigned int host_info_ecx;
+ unsigned int host_info_edx;
+ 
  static int query_hypervisor_info(void)
  {
  	unsigned int eax;
***************
*** 70,82 ****
  		edx = 0;
  		op = HVCPUID_VERSION;
  		cpuid(op, &eax, &ebx, &ecx, &edx);
! 		pr_info("Hyper-V Host OS Build:%d-%d.%d-%d-%d.%d\n",
! 			    eax,
! 			    ebx >> 16,
! 			    ebx & 0xFFFF,
! 			    ecx,
! 			    edx >> 24,
! 			    edx & 0xFFFFFF);
  	}
  	return max_leaf;
  }
--- 74,83 ----
  		edx = 0;
  		op = HVCPUID_VERSION;
  		cpuid(op, &eax, &ebx, &ecx, &edx);
! 		host_info_eax = eax;
! 		host_info_ebx = ebx;
! 		host_info_ecx = ecx;
! 		host_info_edx = edx;
  	}
  	return max_leaf;
  }
***************
*** 133,149 ****
  	int max_leaf;
  	union hv_x64_msr_hypercall_contents hypercall_msr;
  	void *virtaddr = NULL;
  
  	memset(hv_context.synic_event_page, 0, sizeof(void *) * NR_CPUS);
  	memset(hv_context.synic_message_page, 0,
  	       sizeof(void *) * NR_CPUS);
  
  	max_leaf = query_hypervisor_info();
  
  	/*
  	 * Write our OS ID.
  	 */
! 	hv_context.guestid = generate_guest_id(0, LINUX_VERSION_CODE, 0);
  	wrmsrl(HV_X64_MSR_GUEST_OS_ID, hv_context.guestid);
  
  	/* See if the hypercall page is already set */
--- 134,156 ----
  	int max_leaf;
  	union hv_x64_msr_hypercall_contents hypercall_msr;
  	void *virtaddr = NULL;
+ 	__u8 d1 = 0x10; /* SuSE */
+ 	__u16 d2 = 0x0; /* -d of a.b.c-d */
  
  	memset(hv_context.synic_event_page, 0, sizeof(void *) * NR_CPUS);
  	memset(hv_context.synic_message_page, 0,
  	       sizeof(void *) * NR_CPUS);
+ 	memset(hv_context.vp_index, 0,
+ 	       sizeof(int) * NR_CPUS);
+ 	memset(hv_context.event_dpc, 0,
+ 	       sizeof(void *) * NR_CPUS);
  
  	max_leaf = query_hypervisor_info();
  
  	/*
  	 * Write our OS ID.
  	 */
! 	hv_context.guestid = generate_guest_id(d1, LINUX_VERSION_CODE, d2);
  	wrmsrl(HV_X64_MSR_GUEST_OS_ID, hv_context.guestid);
  
  	/* See if the hypercall page is already set */
***************
*** 168,191 ****
  
  	hv_context.hypercall_page = virtaddr;
  
- 	/* Setup the global signal event param for the signal event hypercall */
- 	hv_context.signal_event_buffer =
- 			kmalloc(sizeof(struct hv_input_signal_event_buffer),
- 				GFP_KERNEL);
- 	if (!hv_context.signal_event_buffer)
- 		goto cleanup;
- 
- 	hv_context.signal_event_param =
- 		(struct hv_input_signal_event *)
- 			(ALIGN((unsigned long)
- 				  hv_context.signal_event_buffer,
- 				  HV_HYPERCALL_PARAM_ALIGN));
- 	hv_context.signal_event_param->connectionid.asu32 = 0;
- 	hv_context.signal_event_param->connectionid.u.id =
- 						VMBUS_EVENT_CONNECTION_ID;
- 	hv_context.signal_event_param->flag_number = 0;
- 	hv_context.signal_event_param->rsvdz = 0;
- 
  	return 0;
  
  cleanup:
--- 175,180 ----
***************
*** 213,222 ****
  	/* Reset our OS id */
  	wrmsrl(HV_X64_MSR_GUEST_OS_ID, 0);
  
- 	kfree(hv_context.signal_event_buffer);
- 	hv_context.signal_event_buffer = NULL;
- 	hv_context.signal_event_param = NULL;
- 
  	if (hv_context.hypercall_page) {
  		hypercall_msr.as_uint64 = 0;
  		wrmsrl(HV_X64_MSR_HYPERCALL, hypercall_msr.as_uint64);
--- 202,207 ----
***************
*** 273,285 ****
   *
   * This involves a hypercall.
   */
! u16 hv_signal_event(void)
  {
  	u16 status;
  
! 	status = do_hypercall(HVCALL_SIGNAL_EVENT,
! 			       hv_context.signal_event_param,
! 			       NULL) & 0xFFFF;
  	return status;
  }
  
--- 258,269 ----
   *
   * This involves a hypercall.
   */
! u16 hv_signal_event(void *con_id)
  {
  	u16 status;
  
! 	status = (do_hypercall(HVCALL_SIGNAL_EVENT, con_id, NULL) & 0xFFFF);
! 
  	return status;
  }
  
***************
*** 290,304 ****
   * retrieve the initialized message and event pages.  Otherwise, we create and
   * initialize the message and event pages.
   */
! void hv_synic_init(void *irqarg)
  {
  	u64 version;
  	union hv_synic_simp simp;
  	union hv_synic_siefp siefp;
  	union hv_synic_sint shared_sint;
  	union hv_synic_scontrol sctrl;
  
- 	u32 irq_vector = *((u32 *)(irqarg));
  	int cpu = smp_processor_id();
  
  	if (!hv_context.hypercall_page)
--- 274,288 ----
   * retrieve the initialized message and event pages.  Otherwise, we create and
   * initialize the message and event pages.
   */
! void hv_synic_init(void *arg)
  {
  	u64 version;
  	union hv_synic_simp simp;
  	union hv_synic_siefp siefp;
  	union hv_synic_sint shared_sint;
  	union hv_synic_scontrol sctrl;
+ 	u64 vp_index;
  
  	int cpu = smp_processor_id();
  
  	if (!hv_context.hypercall_page)
***************
*** 307,312 ****
--- 291,305 ----
  	/* Check the version */
  	rdmsrl(HV_X64_MSR_SVERSION, version);
  
+ 	hv_context.event_dpc[cpu] = (struct tasklet_struct *)
+ 					kmalloc(sizeof(struct tasklet_struct),
+ 						GFP_ATOMIC);
+ 	if (hv_context.event_dpc[cpu] == NULL) {
+ 		pr_err("Unable to allocate event dpc\n");
+ 		goto cleanup;
+ 	}
+ 	tasklet_init(hv_context.event_dpc[cpu], vmbus_on_event, cpu);
+ 
  	hv_context.synic_message_page[cpu] =
  		(void *)get_zeroed_page(GFP_ATOMIC);
  
***************
*** 343,351 ****
  	rdmsrl(HV_X64_MSR_SINT0 + VMBUS_MESSAGE_SINT, shared_sint.as_uint64);
  
  	shared_sint.as_uint64 = 0;
! 	shared_sint.vector = irq_vector; /* HV_SHARED_SINT_IDT_VECTOR + 0x20; */
  	shared_sint.masked = false;
! 	shared_sint.auto_eoi = false;
  
  	wrmsrl(HV_X64_MSR_SINT0 + VMBUS_MESSAGE_SINT, shared_sint.as_uint64);
  
--- 336,344 ----
  	rdmsrl(HV_X64_MSR_SINT0 + VMBUS_MESSAGE_SINT, shared_sint.as_uint64);
  
  	shared_sint.as_uint64 = 0;
! 	shared_sint.vector = HYPERVISOR_CALLBACK_VECTOR;
  	shared_sint.masked = false;
! 	shared_sint.auto_eoi = true;
  
  	wrmsrl(HV_X64_MSR_SINT0 + VMBUS_MESSAGE_SINT, shared_sint.as_uint64);
  
***************
*** 356,361 ****
--- 349,362 ----
  	wrmsrl(HV_X64_MSR_SCONTROL, sctrl.as_uint64);
  
  	hv_context.synic_initialized = true;
+ 
+ 	/*
+ 	 * Setup the mapping between Hyper-V's notion
+ 	 * of cpuid and Linux' notion of cpuid.
+ 	 * This array will be indexed using Linux cpuid.
+ 	 */
+ 	rdmsrl(HV_X64_MSR_VP_INDEX, vp_index);
+ 	hv_context.vp_index[cpu] = (u32)vp_index;
  	return;
  
  cleanup:
